
#ifndef CVISITOR_H
#define CVISITOR_H

#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <vector>

#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <vector>
#include <deque>
#include <set>
#include "Ast.h"
#include "AstVisitor.h"

using namespace std;

class CVisitor : public AstVisitor {

 protected:

 ofstream srcFile;

 public:

  CVisitor() {
    srcFile.open("sourcefile.c");
  }

  ~CVisitor() { }

  virtual void visit(FctDef& x) { /* @todo */  }
  virtual void visit(Block& x) { 
    srcFile << endl << "{";
    for ( deque<Statement*>::iterator
	    s = x.getStmts().begin();
	  s != x.getStmts().end();
	  s++ ) {
      (*s)->accept(*this);
    srcFile << endl;
    }
    srcFile << endl << "}" << endl << endl;
  }
  virtual void visit(Parameter& x) { /* @todo */  }
  virtual void visit(IfElseStatement& x) { /* @todo */  }
  virtual void visit(Literal& x) { srcFile << x.getAtom(); }
  virtual void visit(Identifier& x) {srcFile << x.getAtom(); }
  virtual void visit(NaryExpression& x)  { 
    if ( x.getFct() == "+" or
         x.getFct() == "*" or
         x.getFct() == "/" or
         x.getFct() == "-" ) {
      srcFile << "(";
      x.getOperands().at(0)->accept(*this);
      srcFile << x.getFct();
      x.getOperands().at(1)->accept(*this);
      srcFile << ")";
    }
  }
  virtual void visit(Assignment& x)  { 
    srcFile << endl;
    x.getLhs()->accept(*this);
    srcFile << " = ";
    x.getRhs()->accept(*this);
    srcFile << ";";
  }


};

#endif
