class ModelToCodeAst : ModelVisitor {

 protected:

  FctDef *thisFct;
  Block  *currentBlock;

 public:


  virtual void visit(Component& c) {

    // ... Deklarationen , inkl Channels ...

    if ( c.isLeaf() and c.getSm() ) {

      FctDef* f = new FctDef();
      f->setFctName(c.getName());
      ... set qualifier void ...;
      currentBlock = new Block();
      f->setBody(currentBlock);
      c.setSmFct(f);
      thisFct = f;

      // Current location (= leaf control state)
      VarDecl *d = new VarDecl("unsigned int","thisLoc");
      currentBlock->addStmt((Statement*)d);
      //Flag indicating that a transition has 
      // been made
      d = new VarDecl("unsigned int","didTrans");
      currentBlock->addStmt((Statement*)d);

      Block *wBdy = new Block();
      WhileStmt *w = new WhileStmt(new Literal("1"),wBdy);
      currentBlock->addStmt((Statement*)w);

      // Add assignment "thisLoc = c.getSm().getChildren().front()"
      ostringstream oss << c.getSm().getChildren().front().getId();
      Assignment *a = new Assignment(new Identifier("thisLoc"),new Literal(oss.str()));

      currentBlock = wBdy;
      c.getSm()->accept(*this);
    }

  }

  virtual void visit(Statemachine& s) {

    if ( not s.isLeaf() ) return;

    // Create conditional expression
    // thisLoc == 'id s'
    // corresponds to binary operation ==(thisLoc,s.getId())
    NaryExpression *ifInThisLocCnd = new NaryExpression("==");
    ifInThisLocCnd->addOperand(new Identifier("thisLoc"));
    ostringstream oss << s.getId();
    ifInThisLocCnd->addOperand(new Literal(oss.str()));
    Block *ifBlk = new Block();

    IfStatement *ifStmt = new IfStatement(ifInThisLocCnd,
                                          ifBlk);

    list<Composite*> a;
    s.getAncestors(a);

    for (list<Composite*>::iterator
	   n = a.begin();
	 n != a.end();
	 n++ ) {

      Statemachine *loc = dynamic_cast<Statemachine*>n;

      for ( deque<Transition*>::iterator
	      tr = loc->getTrans().begin();
	    tr != loc->getTrans().end();
	    tr++ ) {

	// Create if condition 
	// "didTrans == 0 && (*tr)->getGuard()"
	NaryExpression *op1("==");
	op1->addOperand(new Identifier("didTrans"));
	op1->addOperand(new Literal("0"));
	Expression *op2 = new Expression(*(*tr)->getGuard());
	NaryExpression *ifCnd = NaryExpression("&&");
	ifCnd->addOperand(op1);
	ifCnd->addOperand(op2);
	Block *ifBlk = new Block();

	IfStatement *ifStmt = new IfStatement(ifCnd,ifBlk);
	currentBlock->addStmt(ifStmt);

	// Add assignment "didTrans = 1;"
	Assignment *a = new Assignment(new Identifier("didTrans"),new Literal("1"));
	ifBlk->addStmt(a);

	effect(loc,s,*tr,ifBlk);




      }

    }

    {
    // construct statement
    // if ( didTrans == 0 ) { perform all do actions; }
      NaryExpression *ifCnd = NaryExpression("==");
      ifCnd->addOperand(new Identifier("didTrans"));
      ifCnd->addOperand(new Literal("0"));
      Block *ifBlk = new Block();
      IfStatement *ifNoTrans = new IfStatement(ifCnd,ifBlk);
      currentBlock->addStmt(ifNoTrans);

      for ( Statemachine *x = &s;
	    x != 0;
	    x = dynamic_cast<Statemachine*>(x->getParent()) ) {
	effect(x->getDoAction(),ifBlk);
      }


    }
                 

  }


  void effect(Statemachine *srcLoc,
              Statemachine *leafLoc,
              Transition   *trans,
              Block        *b) {

    Statemachine *tgtLoc = trans->getTgtLoc();
    Statemachine *lca = dynamic_cast<Statemachine*>(srcLoc->lca(tgtLoc));
    Statemachine *tgtLeafLoc;

    // Execute all exit actions
    for ( Statemachine *n = leafLoc;
	  (n and n != lca);
          n = dynamic_cast<Statemachine*>(n->getParent()) ) {
      effect(n->getExitAction(),b);
    }

    // Handle action associated with trans
    effect(trans->getAction(),b);

    // Handle all actions associated with entry into new leaf locations
    tgtLeafLoc = tgtLoc;
    effect(tgtLeafLoc->getEntryAction(),b);
    while ( not tgtLeafLoc->isLeaf() ) {
      Statemachine *aux = tgtLeafLoc->getChildren().front();

      // Effect of action associated with transition from
      // aux to its single target node
      effect(aux->getTrans().front().getAction(),b);
      tgtLeafLoc = aux->getTrans().front().getTgtLoc();
      effect(tgtLeafLoc->getEntryAction(),b);
    }

    // Handle all doactions from lca to top-level location
    for ( Statemachine *n = lca;
	  n != NULL;
          n = dynamic_cast<Statemachine*>(n->getParent()) ) {
      effect(n->getDoAction(),b);
    }

    // Assignment "new leaf location is target-leaf-location
    ostringstream oss << tgtLeafLoc.getId();
    Assignment *newLoc = new Assignment("thisLoc",new Literal(oss.str()));

  }


  // @todo invariants and timers

  void effect(Block *act, Block *b) {

    for ( deque<Statement*>::iterator
	    s = act->getStmts().begin();
	  s != act->getStmts().end();
	  s++ ) {
      b->addStmt(*s);
    }

  }


};
