
class Transition;


class Statemachine : Composite {

 protected:

  deque<Statemachine*> children;
  deque<Transition*> transitions;

  Block entryAction;
  Block exitAction;
  Block doAction;

  Expression *invariant;

  bool initial;
  bool urgent;
  bool commited;

  Component* cmp;

 public:

 Statemachine(Composite* p,
              string name,
              Expression *inv,
              bool ini, bool urg, bool comm) 
   : Composite(p,name) {

    invariant = ini;
...


  }

  void addEntryActionStmt(Statment *s) {
    entryAction.push_back(s);
  }

  void addChild(Statemachine* s) {
    children.push_back(s);
    s->setParent(this);
  }

  void addTransition(Transition *trans) {
    transitions.push_back(trans);
  }


  deque<Statemachine*>& getChildren() { return children; }

  virtual bool isLeaf() { return children.empty(); }

  virtual void accept(ModelVisitor& v) {
    for (  set<Statemachine*>::iterator
	     c = children.begin();
	   c != children.end();
	   c++ ) {
      (*c)->accept(v);
    }

    v.visit(*this);
  }


  deque<Transition*>& getTrans() { return transitions; }

  Component* getParentCmp() const { return cmp; }



};
