

class Composite {

 protected: 
  Composite *parent;
  string name;
  unsigned int id;

  static unsigned int lastId;

 public:

  Composite() {
    id = lastId++;
  }

  Composite *getParent() { return parent; }

  unsigned int getId() { return id; }

  bool isRoot() { return parent == 0; }

  virtual bool isLeaf() = 0;

  string getName() { return name; }

  virtual void accept(ModelVisitor& v);

  virtual void getAncestors(list<Composite*>& a) {
    if ( isRoot() ) return;
    a.push_front(getParent());
    getParent()->getAncestors(a);
  }

  virtual Component* lca(Component* other) {


        Component *myParentNode;
        Component *othersParentNode;

        for ( myParentNode = getParent();
              myParentNode != 0;
              myParentNode = myParentNode->getParent() ) {

            for ( othersParentNode = other->getParent();
                  othersParentNode != 0;
                  othersParentNode = othersParentNode->getParent() ) {

                if ( myParentNode == othersParentNode ) return myParentNode;

            }

        }

        return 0;
  }



};
